<template>
  <div
    v-if="contacts && contacts.length"
    class="so">
    <a
      v-if="getContact(ref.ContactTypes.TELEGRAM)"
      class="so__item _color-telegram"
      :class="sizeIcon"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.TELEGRAM).href"
      @click="$ym('messanger_telegram'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Telegram' }">
      <img
        svg-inline
        src="~/assets/svg/social/telegram-1.svg"
        alt="">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.VIBER)"
      class="so__item _color-viber"
      :class="sizeIcon"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.VIBER).href"
      @click="$ym('messanger_viber'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Viber' }">
      <img
        svg-inline
        src="~/assets/svg/social/viber-1.svg"
        alt="">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.WHATSAPP)"
      class="so__item _color-whatsapp"
      :class="sizeIcon"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.WHATSAPP).href"
      @click="$ym('messanger_whatsapp'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Whatsapp' }">
      <img
        svg-inline
        src="~/assets/svg/social/whatsapp-1.svg"
        alt="">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.SKYPE)"
      class="so__item _color-skype"
      :class="sizeIcon"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.SKYPE).href"
      @click="$ym('messanger_skype'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Skype' }">
      <img
        svg-inline
        src="~/assets/svg/social/skype-1.svg"
        alt="">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.ICQ)"
      class="so__item _color-icq"
      :class="sizeIcon"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.ICQ).href"
      @click="$ym('messanger_icq'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'ICQ' }">
      <img
        svg-inline
        src="~/assets/svg/social/icq-1.svg"
        alt="">
    </a>
  </div>
</template>

<script>
import ContactTypes from '~/assets/js/enums/shop-additional-contacts';

export default {
  name: 'SocialIcons',
  props: {
    sizeIcon: {
      type: String,
      default: '',
    },
    contacts: {
      type: Array,
      default() { return []; },
    },
  },
  data() {
    return {
      popoverBaseClass: 'kit tooltip dark bubble-contact',
      ref: {
        ContactTypes,
      },
    };
  },
  methods: {
    clicked() {
      this.$emit('clicked');
    },
    getContact(typeId) {
      const contact = this.contacts.find(contactItem => Number(contactItem.type_id) === Number(typeId));
      if (!contact) {
        return false;
      }
      let href = '';
      switch (contact.type_id) {
        case this.ref.ContactTypes.SKYPE:
          href = `skype:${contact.value}?chat`;
          break;
        case this.ref.ContactTypes.ICQ:
          href = `http://www.icq.com/people/${contact.value}`;
          break;
        case this.ref.ContactTypes.TELEGRAM:
          href = `tg://resolve?domain=${contact.value}`;
          break;
        case this.ref.ContactTypes.WHATSAPP:
          href = `https://wa.me/${contact.value.replace(/\D/g, '')}`;
          break;
        case this.ref.ContactTypes.VIBER:
          href = `viber://chat?number=${contact.value.replace(/\D/g, '')}`;
          break;
        default:
          return false;
      }
      return {
        ...contact,
        href,
      };
    },
  },
};
</script>

<style
  scoped
  lang="scss">
  .so {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: flex-start;
    align-items: center;

    &__item {
      display: inline-flex;
      border-radius: 50%;
      margin: 0;
      + .so__item {
        margin-left: 0.5rem;
      }
      @media only screen and (min-width: 1025px) {
        &._medium {
          height: 1.5rem;
          width: 1.5rem;
        }
        &._small {
          height: 1.25rem;
          width: 1.25rem;
        }
        &._mini {
          height: 1rem;
          width: 1rem;
        }
      }
      @media only screen and (max-width: 1024px) {
        &._medium {
          height: 2.25rem;
          width: 2.25rem;
        }
        &._small {
          height: 2rem;
          width: 2rem;
        }
        &._mini {
          height: 1.75rem;
          width: 1.75rem;
        }
      }
      svg {
        display: block;
        width: 100%;
        height: 100%;
        margin: auto;
      }
      &._color-telegram {
        svg {
          fill: #27aed6;
        }
      }
      &._color-viber {
        svg {
          fill: #7d519e;
        }
      }
      &._color-whatsapp {
        svg {
          fill: #38aa43;
        }
      }
      &._color-skype {
        svg {
          fill: #00aaf0;
        }
      }
      &._color-icq {
        svg {
          fill: #2fbe00;
        }
      }
    }
  }
</style>
